#!/usr/bin/env python
import random

n = 500
s = 20
t = 20
q = 8 * 10**5
print n,s,t,q

def shuffled(l):
  l = l[:]
  random.shuffle(l)
  return l

def random_hill(dex):
  x = random.randint(-10**6, 10**6)
  y = random.randint(-10**6, 10**6)
  z = random.randint(     0, 10**6)
  return (z, x, y, 1 + dex)

hills = map(random_hill, range(n))

# Partial sort
hills[20:-20] = sorted(hills[20:-20])

options=list(range(n))
assert(s+t<=len(options))
s = map(lambda i: hills[i][3], options[-s:])
t = map(lambda i: hills[i][3], options[:t])

for i in sorted(map(lambda x: (x[3], x[1], x[2], x[0]), hills)):
  print ' '.join(map(str, i[1:]))
print ' '.join(shuffled(list(map(str, s))))
print ' '.join(shuffled(list(map(str, t))))
