# Variables set by configure.
# This file is globally included via Makefile

# General package variables
PACKAGE = checktestdata
VERSION = 20151003
DISTNAME = $(PACKAGE)-$(VERSION)

PACKAGE_NAME      = checktestdata
PACKAGE_VERSION   = 20151003
PACKAGE_STRING    = checktestdata 20151003
PACKAGE_TARNAME   = checktestdata
PACKAGE_BUGREPORT = domjudge-devel@lists.A-Eskwadraat.nl

# Compilers and FLAGS
CC  = gcc
CXX = g++
CPP = gcc -E

CFLAGS   = -g -O2 -Wall -fstack-protector -fPIE -D_FORTIFY_SOURCE=2
CXXFLAGS = -g -O2 -Wall -fstack-protector -fPIE -D_FORTIFY_SOURCE=2
CPPFLAGS = 
LDFLAGS  =  -fPIE -pie -Wl,-z,relro -Wl,-z,now 

STATIC_LINK_START = 
STATIC_LINK_END   = 

EXEEXT = 
OBJEXT = .o

# libboost
BOOST_CPPFLAGS  = -I/usr/include
BOOST_LDFLAGS   = -L/usr/lib/x86_64-linux-gnu
BOOST_REGEX_LIB = -lboost_regex

# libgmpxx
LIBGMPXX = -lgmpxx -lgmp

PARSERGEN_ENABLED = 
