#include <algorithm>
#include <cassert>
#include <vector>
#include <cstdio>
#include <cstring>
#include <string>
using namespace std;

struct Beer{
    string name;
    int units;
    int cost;
} beer[1000];

int main(){
    int cash,pennies,units,_units,n; scanf("%d.%d %d.%d %d",&cash,&pennies,&units,&_units,&n);
    (cash*=100)+=pennies;
    ((units*=10)+=_units)*=6;

    for (int i=0; i<n; i++){
        char namebuf[128],sizebuf[16]={};
        int strength,cost,pennies;
        scanf("%s %d %s %d.%d",namebuf,&strength,sizebuf,&cost,&pennies);
        (cost*=100)+=pennies;
        if (sizebuf[2]=='1') strength*=6/1;
        if (sizebuf[2]=='2') strength*=6/2;
        if (sizebuf[2]=='3') strength*=6/3;
        strength*=10;
        beer[i]={namebuf,strength,cost};
    }

    static int dp[2001][2401];
    memset(dp,-1,sizeof dp);
    dp[0][0]=0;

    for (int i=0; i<n; i++){
        for (int j=0; j+beer[i].cost<=cash; j++){
            for (int k=0; k+beer[i].units<=units; k++) if (~dp[j][k]){
                dp[j+beer[i].cost][k+beer[i].units]=i;
            }
        }
    }

    if (!~dp[cash][units]){
        puts("IMPOSSIBLE");
        return 0;
    }

    vector<pair<string,int>> res;
    for (int i=cash,j=units,cnt=0; i>0;){
        int x=dp[i][j];
        i-=beer[x].cost;
        j-=beer[x].units;
        ++cnt;
        if (i==0 or dp[i][j]!=x){
            res.emplace_back(beer[x].name,cnt);
            cnt=0;
        }
    }

    sort(res.begin(),res.end());
    for (auto &p: res)
        printf("%s %d\n",p.first.c_str(),p.second);
}
