#include <algorithm>
#include <iostream>
#include <cassert>
#include <cmath>
#include <set>
using namespace std;
typedef long long ll;
#define circle 360000

struct place{
    ll dist;
    ll angle;
} place[20000];

struct taxi{
    ll min_dist;
    ll max_angle;
} taxi[200];

multiset<ll> calc(multiset<ll> all){
    if (all.size()<=1) return {circle};
    multiset<ll> res;
    auto jt=all.end(); --jt;
    for (auto it=all.begin(); it!=all.end(); (jt=it), ++it){
        res.insert((*it-*jt+circle)%circle);
    }
    return res;
}

int main(){
    int t,n; cin>>t>>n;

    for (int i=0; i<t; i++){
        cin>>taxi[i].min_dist>>taxi[i].max_angle;
    }
    for (int i=1; i<n; i++){
        cin>>place[i].dist>>place[i].angle;
        place[i].dist+=place[i-1].dist;
        (place[i].angle+=place[i-1].angle+circle)%=circle;
    }

    static int need[20001];
    for (int j=0; j+1<n; j++)
        need[j]=n+1;

    static int _a[201],_b[201];
    for (int i=t; i--;) _a[i]=_b[i]=n;
    multiset<ll> _values[201],_angles[201],_dangles[201];

    for (int j=n; j--;){
        for (int i=t; i--;){
            auto &a=_a[i],&b=_b[i];
            auto &values=_values[i],&angles=_angles[i],&dangles=_dangles[i];

            // insert new angle
            if (j+1<n){
                angles.insert(place[j+1].angle);
                dangles=calc(angles);
            }
            // move left bound
            while (a>j+1 and place[a-1].dist-place[j].dist>=taxi[i].min_dist){
                --a;
                values.insert(need[a]);
            }
            // move right bound
            while (b>a and (circle-*dangles.rbegin())%circle>taxi[i].max_angle){
                --b;
                values.erase(values.find(need[b]));
                angles.erase(angles.find(place[b].angle));
                dangles=calc(angles);
            }

            if (true){
                need[j]=min(need[j],need[j]);
            }
            if (not values.empty()){
                need[j]=min(need[j],(int)(1+*values.begin()));
            }
        }
    }

    if (need[0]<=n){
        cout<<need[0]<<endl;
    }else{
        cout<<"IMPOSSIBLE\n";
    }
}
