#include <algorithm>
#include <iostream>
#include <cassert>
#include <cmath>
#include <set>
using namespace std;
typedef long long ll;
#define circle 360000

struct place{
    ll dist;
    ll angle;
} place[50000];

struct taxi{
    ll min_dist;
    ll max_angle;
} taxi[200];

int main(){
    int t,n; cin>>t>>n;
    for (int i=0; i<t; i++){
        cin>>taxi[i].min_dist>>taxi[i].max_angle;
    }
    for (int i=1; i<n; i++){
        cin>>place[i].dist>>place[i].angle;
        (place[i].angle+=place[i-1].angle+circle)%=circle;
    }

    int cost=0;
    for (int x=0; x+1<n; ++cost){
        int y=x;
        for (int i=0; i<t; i++){
            ll dist=0;
            set<int> angles;
            for (int k=x+1; k<n; k++){
                // insert new angle
                angles.insert(place[k].angle);

                // update distance
                dist+=place[k].dist;
                if (dist<taxi[i].min_dist) continue;

                int hrange=(angles.size()<=1? 0: circle);
                for (auto a=angles.begin(),b=--angles.end(); a!=angles.end(); b=a++){
                    hrange=min(hrange, circle-(((*a-*b)+circle)%circle));
                }
                if (hrange>taxi[i].max_angle) break;

                y=max(y,k);
            }
        }
        if (x==y) {cost=-1; break;} else x=y;
    }

    if (~cost){
        cout<<cost<<endl;
    }else{
        cout<<"IMPOSSIBLE\n";
    }
}
