#!/usr/bin/env python
import random
import numpy as np

def modpow(x,y,z):
    if y <= 1: return x % z if y == 1 else 1
    return (modpow((x*x) % z, y/2, z) * modpow(x, y%2, z)) % z

def str_to_list(s):
    rem = {}
    for i in s:
        if i not in rem:
            rem[i] = 1 + len(rem)
    s = [1] + list(map(lambda x: rem[x], s))
    for i in range(1,len(s)):
        s[i] *= s[i-1]
    return s

m = str_to_list('ab' * 10)
n = str_to_list('ab' * 25)

m = np.add(np.cumsum([0] + m), 100)
n = np.add(np.cumsum([0] + n), 100)

print len(m),len(n)
try:
    print ' '.join(map(lambda x: str(x), m))
    print ' '.join(map(lambda x: str(x), n))
except:
    pass
