#include <algorithm>
#include <iostream>
#include <cassert>
#include <utility>
#include <vector>
#include <set>
#include <map>
using namespace std;
typedef long long ll;

ll p[1000001];
ll x[1000001];

map<pair<ll,ll>,int> need;
ll gcd(ll a,ll b){return b?gcd(b,a%b):a;}
pair<ll,ll> frac(ll a,ll b){assert(b); ll g=a?gcd(a,b):1;a/=g,b/=g;return {a,b};}

void up(ll *p, int j)  {if (not ++need[frac(p[j]-p[j-1],p[j]-p[j-2])]) need.erase(frac(p[j]-p[j-1],p[j]-p[j-2]));}
void down(ll *x, int j){if (not --need[frac(x[j]-x[j-1],x[j]-x[j-2])]) need.erase(frac(x[j]-x[j-1],x[j]-x[j-2]));}

int main(){
    ios::sync_with_stdio(false);

    int m,n; cin>>m>>n;
    for (int i=0; i<m; i++) cin>>p[i];
    for (int i=0; i<n; i++) cin>>x[i];
    for (int i=2; i<m; i++) up(p,i), down(x,i);

    set<ll> res;
    for (int i=0; i+m<=n; i++){
        bool ok=need.empty() and not res.count(x[i+1]-x[i]);
        for (int j=2; ok and j<m; j++){
            if ((x[i+j]-x[i+j-1])*(__int128)(p[1]-p[0]) != (x[i+1]-x[i])*(__int128)(p[j]-p[j-1])){
                ok=false;
            }
        }
        if (ok){
            res.insert(x[i+1]-x[i]);
        }
        up(x,i+2), down(x,i+m);
    }

    cout<<res.size()<<endl;
    {int space=0; for (auto i: res) cout<<(space++?" ":"")<<i; cout<<endl;}
}
