#!/usr/bin/env perl

use strict;
use warnings;

my $letters = 5 + int(rand 9995);
my @word = ('a') x $letters;

sub vowel {substr('aeiou', (int rand 5), 1)}
sub hard {substr('bcdgknpt', (int rand 8), 1)}
sub soft {substr('fhjlmqrsvwxyz', (int rand 13), 1)}

for my $i (0 .. $letters-1) {
    my $type = int rand 3;
    $word[$i] = vowel if $type == 0;
    $word[$i] = hard if $type == 1;
    $word[$i] = soft if $type == 2;
}

my $dashes = int(rand (($letters - 2) / 8));
for my $i (0 .. $dashes-1) {
    $word[1 + int rand($letters-2)] = '-';
}

my $spaces = int(rand 50);
for my $i (0 .. $spaces-1) {
    $word[1 + int rand($letters-2)] = ' ';
}

my $word = ucfirst join('', @word);
$word =~ s/^ +| +$//g;
$word =~ s/ +/ /g;
$word =~ s/-+/-/g;
$word =~ s/ -|- / /g;
$word =~ s/^-|-$//g;
print "$word\n";
