#!/usr/bin/env python
import math

xy = map(lambda _: map(int, raw_input().split()) + [0.0], range(int(raw_input())))

def go(xy, r):
  hull = []
  for i in r:
    while len(hull) >= 1 and xy[hull[-1]][1] <= xy[i][1]:
        hull.pop()
    while len(hull) >= 2 and (xy[hull[-1]][1]-xy[i][1])*abs(xy[hull[-2]][0]-xy[i][0]) <= (xy[hull[-2]][1]-xy[i][1])*abs(xy[hull[-1]][0]-xy[i][0]):
        hull.pop()
    if len(hull) == 0:
        xy[i][2] += 6.0
    else:
        xy[i][2] += 12.0/math.pi*math.atan2(abs(xy[hull[-1]][0]-xy[i][0]),xy[hull[-1]][1]-xy[i][1])
    hull += [i]

go(xy,range(len(xy)))
go(xy,range(len(xy)-1,-1,-1))
for i in xy: print i[2]
