#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
using namespace std;
typedef double ld;

pair<int,int> v[1000000];
ld phase[2][1000000];

ld angle(int a,int b){
    if (a==-1 or b==-1 or v[b].second<=v[a].second) return 0.5*M_PI;
    return atan2(abs(v[a].first-v[b].first), v[b].second-v[a].second);
}

int main(){
    int n; cin>>n;
    cout.precision(8);
    ios::sync_with_stdio(false);
    cout<<fixed;
    for (int i=0; i<n; i++){
        cin>>v[i].first>>v[i].second;
    }
    for (int i=0; i<n; i++){
        phase[0][i]=phase[1][i]=0.5*M_PI;
        for (int j=0; j<i; j++) phase[0][i]=min(phase[0][i],angle(i,j));
        for (int j=i+1; j<n; j++) phase[1][i]=min(phase[1][i],angle(i,j));
        cout<<(phase[0][i]+phase[1][i])*12./M_PI<<"\n";
    }
}
