#!/usr/bin/env python
from __future__ import print_function
import random ; from random import randint
import sys

def fixed(n,d):
    return ('%d.%0' + str(d) + 'd') % (n/(10**d), n%(10**d))

class Beer:
    def __init__(self, name):
        self.name = name
        self.strength = randint(1, 7)
        self.size = 6 / randint(1, 3)
        self.cost = randint(1, 100)

beers = map(lambda x: Beer(x), ['punkipa','deadpony','vagabond','thisislager','fiveamred','bomber','kronenbourg','vodka'])
money = 0
units = 0

while True:
    beer = random.choice(beers)
    if money + beer.cost > 1000 or units + beer.size * beer.strength > 20 * 6:
        break
    money += beer.cost
    units += beer.size * beer.strength

units *= 10
units /= 6

print(fixed(money, 2), fixed(units, 1), len(beers))
for i in beers:
    print(i.name,i.strength,'1/'+str(6/i.size),fixed(i.cost,2))
