#include <iostream>
#include <vector>
#include <cmath>

#define PI 2*acos(0)

using namespace std;

int main(void) {
	int N;
	double G;
	vector<double> angles;
	vector<double> distances;

	cin >> N >> G;
	
	for( int i = 0; i < N; ++i ) {
		double tmpD, tmpA;
		cin >> tmpD >> tmpA;
		distances.push_back(tmpD);
		tmpA = (tmpA / 180) * PI;
		angles.push_back(tmpA);
	}
	cout.precision(10);

	
	for( int i = 0; i < N; ++i ) {
		double cur_v = 0;	
		for( int j = i; j < N; ++j ) {
			cur_v = sqrt( 2 * distances[j] * G * cos(angles[j]) + cur_v * cur_v );
		}
		cout << cur_v << endl;
	}	
	return 0;
}
