#include <iostream>
#include <vector>
#include <cmath>

#define PI 2*acos(0)

using namespace std;

double getVfromH( double g, double h ) {
	return sqrt( 2 * g * h );
}

int main(void) {
	int N;
	double G;
	vector<double> heights; 
	double total = 0;
	
	cin >> N >> G;
	
	for( int i = 0; i < N; ++i ) {
		double tmpA, tmpD;
		cin >> tmpD >> tmpA;
		tmpA = (tmpA / 180) * PI;
		heights.push_back( cos(tmpA) * tmpD );	
		total += cos(tmpA) * tmpD;
	}
	cout.precision(10);
	for( int i = 0; i < N; ++i ) {
		cout << getVfromH( G, total) << endl;
		total -= heights[i];
	}
	
	return 0;
}
