#include <iostream>
#include <vector>
#include <cmath>
#include <cstdio>

using namespace std;

int main()
{
	int n;
	double g;

	cin >> n >> g;

	vector<double> d(n), th(n);
	for(int i=0; i<n; i++) cin >> d[i] >> th[i];

	vector<double> h(n+1,0);
	for(int i=n-1; i>=0; i--) h[i] = h[i+1] + d[i]*cos(th[i]*M_PI/180);

	cout.precision(10);
	for(int i=0; i<n; i++) cout << sqrt(2*g*h[i]) << endl;

	return 0;
}
