#include <algorithm>
#include <iostream>
#include <cassert>
#include <cmath>
#include <set>
using namespace std;
typedef long long ll;
#define circle 360000

struct place{
    ll dist;
    ll angle;
} place[20000];

struct taxi{
    ll min_dist;
    ll max_angle;
} taxi[200];

int main(){
    int t,n; cin>>t>>n;

    for (int i=0; i<t; i++){
        cin>>taxi[i].min_dist>>taxi[i].max_angle;
    }
    for (int i=1; i<n; i++){
        cin>>place[i].dist>>place[i].angle;
        (place[i].angle+=place[i-1].angle+circle)%=circle;
    }

    static int need[20001];
    for (int j=0; j+1<n; j++)
        need[j]=n+1;

    for (int j=n; j--;){
        for (int i=t; i--;){
            ll dist=0;
            set<ll> angles;
            for (int k=j+1; k<n; k++){
                // insert new angle
                angles.insert(place[k].angle);
                ll hrange=circle;
                for (auto a=angles.begin(),b=--angles.end(); a!=angles.end(); b=a++){
                    hrange=min(hrange, (circle-(*a-*b))%circle);
                }

                // update distance
                dist+=place[k].dist;

                // check validity
                if (dist>=taxi[i].min_dist and hrange<=taxi[i].max_angle){
                    need[j]=min(need[j],need[k]+1);
                }
            }
        }
    }

    if (need[0]<=n){
        cout<<need[0]<<endl;
    }else{
        cout<<"IMPOSSIBLE\n";
    }
}
