#include <algorithm>
#include <iostream>
#include <vector>
#include <cmath>
using namespace std;

// TODO: Wrong. Assumes closest edge contains centre. Fix with proper
// point-in-polygon detection and then add this version to failures.

struct vec2 {long long x,y; vec2 operator+(vec2 const a)const{return {x+a.x,y+a.y};}};
long long dot(vec2 a,vec2 b){return a.x*b.x+a.y*b.y;}
double clamp(double x,double a,double b){return max(min(x,b),a);}

int main(){
  ios::sync_with_stdio(false);

  int n; cin>>n;
  double res=1e60L;

  // height at (0,0)
  pair<double,double> origin={1e60L,1e60L};

  for (int i=0; i<n; i++){
    int h0,h1,m; cin>>h0>>h1>>m;
    static vec2 v[1000000];
    for (int j=m; j--;) cin>>v[j].x>>v[j].y;
    for (int j=0,k=m-1; j<m; k=j++){
      vec2 a=v[j],b=v[k],w={b.x-a.x,b.y-a.y};
      double t=clamp(-1.L*dot(a,w)/(double)dot(w,w),0,1);
      double cdist=hypot(a.x+w.x*t,a.y+w.y*t);
      res=min(res,(double)hypot(cdist,h0));
      origin=min(origin,{cdist,h1});
    }
  }
  res=min(res,origin.second);

  cout.precision(10);
  cout<<fixed<<res<<endl;
}
