#include <iostream>
#include <cctype>
#include <string>
#include <regex>
using namespace std;

char to[256];

int main(){
  string src; getline(cin,src);
  vector<vector<string>> s={{""}};
  for (auto i: src)
    switch (i){
      case ' ': s.emplace_back();
      case '-': s.back().emplace_back(""); break;
      default: s.back().back()+=i;
    }

  for (char c: "bcdgknpt")
    for (char i='a'; i<='z'; i++)
      if (abs(i-c)<abs(i-to[i]))
        to[i]=c, to[toupper(i)]=toupper(c);

  for (auto &word: s){
    // Rule 1
    word[0][0]=to[word[0][0]];

    bool first=true;
    for (auto &syllable: word){
      if (not first){
        for (auto &c: syllable){
          // Rule 2
          if (c==to[c]) c=(islower(c)? tolower(word[0][0]): toupper(word[0][0]));
        }
      }
      first=false;
    }

    // Rule 3
    if (word.back().back()==to[word.back().back()]){
      string t="ah";
      for (char c: "aou")
        if (abs(tolower(word.back().back())-c)<=abs(tolower(word.back().back())-t[0]))
          t[0]=c;
      word.back()+=t;
    }
  }

  bool first=true;
  for (auto const &word: s){
    if (first) first=false; else cout<<" ";
    for (auto const &syllable: word){
      cout<<syllable;
    }
  }

  cout<<endl;
}
