#include <iostream>
#include <vector>
#include <cmath>
#include <cstdio>

using namespace std;

double sqr(double x) { return x*x; }

int main()
{
	int T;
	double c, d, x;

	cin >> T >> c >> d;
	x = 3600*c*sqr(d);

	vector<int> r(T);
	for(int i=0; i<T; i++) cin >> r[i];

	double best = 1E99;

	for(int a=0; a<T; a++) {
		for(int b=a; b<T; b++) {
			int rsum = 0;
			for(int i=a; i<=b; i++) rsum += r[i];
			int m = max(r[a],r[b]);
			double t = sqrt(x/m);
			if ( t<(b-a) || t>(b-a+1) ) t = b-a+1;
			double curr = x/t + rsum - m*(b-a+1-t);
			if ( curr < best ) best = curr;
		}
	}

	cout.precision(10);
	cout << best << endl;

	return 0;
}
