#include <algorithm>
#include <cstdint>
#include <cstdio>
using namespace std;

#define CUTOFF 0xFFFF

uint64_t cell[2001][2001];

void paint(int r,int c){
    cell[r][c]=0;
    for (int dr=0,dc=1,z=4; z--; swap(dr,dc=-dc))
        if (r+dr>=0 and c+dc>=0 and cell[r+dr][c+dc] >= CUTOFF)
            paint(r+dr,c+dc);
}

int main(){
    int n,r,c; scanf("%d%d%d",&n,&r,&c);
    int res=0;

    for (int i=0; i<r; i++)
        for (int j=0; j<c; j++)
            scanf("%llx",&cell[i][j]);
    for (int i=r; i--;)
        for (int j=c; j--;)
            if (cell[i][j]) paint(i,j), ++res;

    printf("%d\n",res);
}
